# Copyright (C) 2012, Linaro Limited.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
from selenium import webdriver
from selenium.common.exceptions import TimeoutException
from selenium.webdriver.support.ui import WebDriverWait
import time

all_browser_drivers = []
all_browser_drivers.append(webdriver.Chrome())
#all_browser_drivers.append(webdriver.Firefox())

all_tests = []

def octane_test(driver):
    driver.get("http://octane-benchmark.googlecode.com/svn/latest/index.html")
    element = driver.find_element_by_css_selector("#main-banner")
    element.click()
    WebDriverWait(element, 1000).until(lambda element : element.text.startswith("Octane Score:"))
    element = driver.find_element_by_css_selector("#main-banner")
    text = element.text
    text = text[text.find(":")+2:].lstrip()
    return text
octane_test.name = "octane"
all_tests.append(octane_test)

def kraken_test(driver):
    driver.get("http://krakenbenchmark.mozilla.org")
    element = driver.find_element_by_link_text("Begin")
    element.click()
    try:
	WebDriverWait(driver, 1000).until(lambda driver : driver.find_element_by_id("console"))
    finally:
	pass
    element = driver.find_element_by_id("console")
    text = element.text
    text = text[text.find("Total:")+6:text.find("ms")-2].lstrip()
    return text
kraken_test.name = "kraken"
all_tests.append(kraken_test)

def main():
    for driver in all_browser_drivers:
	for test in all_tests:
	    score = test(driver)
	    print "%s_%s: %s" % (driver.name, test.name, score)

if __name__ == '__main__':
    raise SystemExit(main())
